#include "LedControl.h"
#include "PinChangeInterrupt.h"
#include "game.h"

LedControl lc=LedControl(12,11,10,1);

/**
 * The game which we will play
 */
MazeGame mazeGame;

void setup() {
  lc.shutdown(0,false);
  /**
   * Set intensity to a lower value than 1 because 1
   * hurts my eyes, 0.3 is almost too bright as well
   */  
  lc.setIntensity(0,3);
  /**
   * Clear the display
   */
  lc.clearDisplay(0);

  mazeGame.setLc(lc);

  pinMode(UP_BUTTON, INPUT_PULLUP);
  pinMode(DOWN_BUTTON, INPUT_PULLUP);
  pinMode(LEFT_BUTTON, INPUT_PULLUP);
  pinMode(RIGHT_BUTTON, INPUT_PULLUP);

  /**
   * Interrupts for the buttons
   * UP and DOWN are actual interrupts
   * LEFT and RIGHT use PCINT
   * 
   * Had to use LAMBDA FUNCTIONS
   */
  attachInterrupt(digitalPinToInterrupt(UP_BUTTON), [](){mazeGame.upButtonAction();}, FALLING);
  attachInterrupt(digitalPinToInterrupt(DOWN_BUTTON), [](){mazeGame.downButtonAction();}, FALLING);
  attachPCINT(digitalPinToPCINT(LEFT_BUTTON), [](){mazeGame.leftButtonAction();}, FALLING);
  attachPCINT(digitalPinToPCINT(RIGHT_BUTTON), [](){mazeGame.rightButtonAction();}, FALLING);
}


void loop() {  
  if (mazeGame.checkWon()) {
    mazeGame.displayVictory();
  } else {
    mazeGame.setDisplay(mazeGame.maps.current_map);
  }

}